<Query Kind="Program" />

void Main() {
  // 建立person物件或執行個體  
  // Email和Gender屬性只能在初始進行設定  
  var person = new Person(){Gender="男",Email="rico@test.com",Age=8};

  // 設定屬性值
  person.Name = "Rico";
  person.Age = 18;
  person.Email="newrico@test.com";//Email屬性值後續可變更
  Console.WriteLine(person.Gender);//Gender屬性值後續不可變更
  Console.WriteLine(person.Email);//newrico@test.com
  Console.WriteLine($"Birthday:{person.Birthday}");//null

  // 呼叫方法
  Console.WriteLine(person.GetInfo()); //Age = 18

  // 呼叫無返回值的方法
  person.IncreaseAge(5); 
  
  // 呼叫返回值的方法
  Console.WriteLine(person.GetInfo()); //Age =23

  // 呼叫靜態方法
  Person.DisplayGreeting();
}

//定義 Person 類別
//sealed關鍵字可避免被繼承
public sealed class Person
{
    // 私有字串資料
    private string name;

    // 屬性（提供對字串的存取控制）
    public string Name
    {
        get { return name; }    // 讀
        set { name = value; }   // 寫
    }

    // 自動屬性
    public int Age { get; set; }
	
	// init初始設定後不能修改
	public string Gender {get; init;}	
	
	// required 初始設定後可修改
	public required string Email{get;set;}
	
	// ?可接受null
	public DateTime? Birthday{get;set;}	

    // 方法（有返回值）
    public string GetInfo()
    {
        return $"Name: {Name}, Age: {Age}";
    }

    // 方法（無返回值）
    public void IncreaseAge(int years)
    {
        Age += years;
    }

    // 靜態方法
    public static void DisplayGreeting()
    {
        Console.WriteLine("Hello! Welcome to the Person class.");
    }
}